package at.oefai.aaa.agent.jam;

import java.util.List;

import at.oefai.aaa.agent.jam.types.Value;

/**
 * Simple abstracting interface of an animating object, that can be triggered and provides feedback.
 * @author Stefan Rank
 */
public interface Animator {

    Animator.ITask animate(final String actor, final String actionName, final List<Value> arguments);

    /**
     * This interface is returned for each animation, it can be polled for task completion.
     * @author wrstlprmpft
     */
    public interface ITask {
        boolean isFinished();
    }
}
