package at.oefai.aaa.agent.jam;

import java.io.Serializable;

import at.oefai.aaa.agent.jam.types.Binding;

/**
 * A built-in JAM primitive action for adding entries to the JAM world model.
 * @author Marc Huber
 * @author Jaeho Lee
 */
class AssertAction extends WorldModelAction implements Serializable {

    /** Constructor w/ relation to assert to the World Model as an argument in addition to the interpreter. */
    AssertAction(final Relation pRelation, final WorldModelTable pWorldModel) {
        super(pRelation, pWorldModel);
    }

    // Member functions

    public boolean isExecutableAction() { return true; }

    /** Add the relation to the World Model. */
    public Result execute(final Binding b, final Goal currentGoal) {
        this.worldModel.assertRelation(this.relation, b);
        return Result.SUCCEEDED;
    }


    /** Output information to the stream in an in-line manner. */
    public String formattedString(final Binding b) {
        return "ASSERT " + this.relation.formattedString(b) + ";";
    }

}

