package at.oefai.aaa.agent.jam;

import java.io.Serializable;

import at.oefai.aaa.agent.jam.types.Binding;
import at.oefai.aaa.agent.jam.types.Expression;

/**
 * A built-in JAM primitive action for perpetually keeping a state expression true.
 * @author Marc Huber
 */
class MaintainGoalAction extends GoalAction implements Serializable {

    /** Primary constructor. */
    public MaintainGoalAction(final Relation goal, final Expression utility) {
        super(goal, utility);
    }


    // Member functions

    public boolean isExecutableAction() { return false; }

    /** Display information about the goal. */
    public String formattedString(final Binding b) {
        return formattedStringEnhanced(b, "MAINTAIN ", ";");
    }

}

