package at.oefai.aaa.agent.jam;

import java.io.Serializable;

import at.oefai.aaa.agent.jam.types.Binding;
import at.oefai.aaa.agent.jam.types.Value;

/**
 * Retrieve Predicate (a World Model Retrieve expression evaluable to true/false).
 * @author Marc Huber
 * @author Jaeho Lee
 */
class PredicateRetrieve extends Predicate implements Serializable {

    private final WorldModelTable worldModel;

    /** Primary constructor. */
    PredicateRetrieve(final String name, final Relation relation, final WorldModelTable pWorldModel) {
        super(name, relation);
        this.worldModel = pWorldModel;
    }


    // Member functions


    /** Calculate the truth value of the World Model relation. */
    public Value eval(final Binding binding) {
        // unbind variables before matching
        binding.unbindVariables(this.relation.getArgs());

        // now try match to get new values
        if (this.worldModel.match(this.relation, binding)) {
            return Value.TRUE;
        }
        return Value.FALSE;
    }

}

