package at.oefai.aaa.agent.jam;

import java.io.Serializable;

import at.oefai.aaa.agent.jam.types.Binding;
import at.oefai.aaa.agent.jam.types.Expression;

/**
 * A built-in JAM primitive action for evaluating boolean expressions.
 * @author Marc Huber
 * @author Jaeho Lee
 */
class TestAction extends AbstractAction implements Serializable {

    private Expression expression;

    /**  */
    TestAction(final Expression e) {
        this.expression = e;
    }

    // Member functions

    public boolean isExecutableAction() { return true; }

    public Expression getExp() { return this.expression; }

    /**  */
    public Result execute(final Binding b, final Goal currentGoal) {
        return this.expression.eval(b).isTrue() ? Result.SUCCEEDED : Result.FAILED;
    }

    /**  */
    public String formattedString(final Binding b) {
        return "TEST:" + this.expression.formattedString(b);
    }

    public String getName() {
        return "TestAction";
    }
}

