package at.oefai.aaa.agent.jam.types;


/**
 * Represents the basic data-types within JAM agents.
 * @author Marc Huber
 * @author Jaeho Lee
 */
public abstract class AbstractExpression implements Expression {
    /** Evaluates the expression to a single resultant (whether the two values are equivalent). */
    public final boolean equals(final Expression e, final Binding b) {
        Value one = this.eval(b);
        Value two = e.eval(b);
        if (one.isDefined()) {
            return two.isDefined() ? one.eq(two) : false;
        }
        return two.isDefined() ? false : true;
    }

    /** Evaluates the expression to a single resultant (whether the first value is "less than" the second value). */
    public final boolean lessthan(final Expression e, final Binding b) {
        Value one = this.eval(b);
        Value two = e.eval(b);
        if (one.isDefined()) {
            return two.isDefined() ? one.lt(two) : false;
        }
        return two.isDefined() ? false : true;
    }

}
