package at.oefai.aaa.agent.jam.types;

import java.io.Serializable;

/**
 * Represents the basic data-types within JAM agents.
 * @author Marc Huber
 * @author Jaeho Lee
 */

public interface Expression extends Serializable {
    // abstract output functions
    String verboseString(Binding b);
    String formattedString(Binding b);

    /** Evaluates the expression to a single resultant. */
    Value eval(Binding b);

    /** Evaluates this and the expression and compares, true if equal. */
    boolean equals(Expression e, Binding b);

    /** Evaluates this and the expression and compares, true if this is 'smaller'. */
    boolean lessthan(Expression e, Binding b);

}

