package at.oefai.aaa.animation;

import org.w3c.dom.svg.SVGSVGElement;

/**
 * SVG anim for directly setting the position of an object to an agents hands.
 * @author Stefan Rank
 */
public class SetAgentHasObject extends BaseSVGAnim {
    private volatile boolean done = false;

    public BaseAnim newInstance() { return new SetAgentHasObject(); }

    protected void doFirstTime() {
        assert (this.args.size() == 2) : "wrong arguments for SetAgentHasObject";
        String theObject = this.args.get(1).getString();
        SVGSVGElement eleAgent = getNamedElement(this.args.get(0).getString());
        SVGSVGElement eleObject = getNamedElement(theObject);
        // for set dont check if eleBelow already has a child svg (move would need to check)
        // take out above element from where it is now:
        if ((eleObject != null) && (eleAgent != null)) {
            eleObject.getParentNode().removeChild(eleObject);
            setElementsPos(eleObject, getCoordsOfAgentsObject(eleObject, eleAgent));
            // put it under Agent in the tree (which puts it above on screen;-)
            eleAgent.appendChild(eleObject);
            hideElement(theObject + SHADOW_POSTFIX);
            adjustHolding(eleAgent);
        }
        this.done = true;
    }


    public boolean isFinished() {
        return this.done;
    }

    protected void doIt() {
        //override
    }

}
