package at.oefai.aaa.gui;

import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;

/**
 * The StatusPanel is displaying info about the status of the program.
 * Uses two sections, one prefixed with Graphics-Status:
 * @author Stefan Rank
 */
public class StatusPanel extends JPanel {
    private static final String GRAPHICS_LABEL_TEXT = "Graphics-Status: ";
    private JLabel statusText = new JLabel();
    private JLabel graphicsText = new JLabel(GRAPHICS_LABEL_TEXT);

    public StatusPanel(final String pStatusText) {
        // standard FlowLayout is fine, but leading aligned
        setLayout(new GridLayout(1, 2));
        // setBorder(BorderFactory.createLoweredBevelBorder());
        // setBorder(BorderFactory.createEmptyBorder(1,1,1,1));
        setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
        this.statusText.setText(pStatusText);
        add(this.statusText);
        add(this.graphicsText);
    }

    public final void setStatusText(final String s) {
        this.statusText.setText(s);
    }

    public final void setGraphicsText(final String s) {
        this.graphicsText.setText(GRAPHICS_LABEL_TEXT + s);
    }

}
