package at.oefai.aaa.thread;

/**
 * Implementors can be used like runnables with StoppableThread.
 * difference is run() of Runnable is the whole thing
 * runOneLoop() here is called repeatedly until isComplete returns true
 * onStart() and onStop() are hooks called by StoppableThread
 * @author Stefan Rank
 */
public interface IStoppable {
    void runOneLoop();
    boolean isCompleted();
    void onStop();
    void onStart();
}
